import { Getter, Store } from '@bcase/vuex';
import { database } from 'firebase';
export declare type MutationIdMap<S extends Store.Tree = any> = {
    [T in keyof S['Mutation']]?: (payload: S['Mutation'][T]) => string;
};
export interface FirebaseModule<S extends Store.Tree = any, R extends Store.Tree = any> extends Store.Module<S, R> {
    firebase: {
        database: database.Database | Getter.Definition<S, R, database.Database>;
        reference: string | Getter.Definition<S, R, string | undefined | null>;
        CHILD_CHANGED?: MutationIdMap<S>;
        CHILD_REMOVED?: MutationIdMap<S>;
    };
}
