import { MutationIdMap } from './firebase-module';
export declare class ModuleSettings {
    private readonly id;
    readonly changeMap: Map<string, (payload: any) => string>;
    readonly removeMap: Map<string, (payload: any) => string>;
    initialized: boolean;
    defaultState: any;
    reSync?: (oldRef?: string | null, newRef?: string | null) => void;
    readonly getters: {
        readonly DB: string;
        readonly REF: string;
        readonly STATE: string;
    };
    readonly mutations: {
        readonly CHILD_ADD: string;
        readonly CHILD_CHANGE: string;
        readonly CHILD_REMOVE: string;
        readonly RESET: string;
    };
    constructor(changeMap?: MutationIdMap, removeMap?: MutationIdMap);
    private toMap;
}
