import { generateId } from '../utils/generate-id';
var ModuleSettings = /** @class */ (function () {
    function ModuleSettings(changeMap, removeMap) {
        this.id = generateId();
        this.changeMap = this.toMap(changeMap);
        this.removeMap = this.toMap(removeMap);
        this.initialized = false;
        this.getters = {
            DB: "$" + this.id + "-DB",
            REF: "$" + this.id + "-REF",
            STATE: "$" + this.id + "-STATE"
        };
        this.mutations = {
            CHILD_ADD: "$" + this.id + "-ADD",
            CHILD_CHANGE: "$" + this.id + "-CHANGE",
            CHILD_REMOVE: "$" + this.id + "-REMOVE",
            RESET: "$" + this.id + "-RESET"
        };
    }
    ModuleSettings.prototype.toMap = function (value) {
        var values = value
            ? Object.keys(value).map(function (key) { return [key, value[key]]; })
            : [];
        return new Map(values);
    };
    return ModuleSettings;
}());
export { ModuleSettings };
//# sourceMappingURL=module-settings.js.map