var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
import Vue from 'vue';
import { ModuleSettings } from './models/module-settings';
import { FIREBASE_INITS, FIREBASE_MUTATIONS } from './utils/dictionaries';
export function firebaseModule(mod) {
    var _a, e_1, _b, _c;
    // Extract extra properties
    var firebase = mod.firebase, rest = __rest(mod, ["firebase"]);
    var database = firebase.database, reference = firebase.reference, CHILD_CHANGED = firebase.CHILD_CHANGED, CHILD_REMOVED = firebase.CHILD_REMOVED;
    var module = rest;
    // Generate settings
    var settings = new ModuleSettings(CHILD_CHANGED, CHILD_REMOVED);
    FIREBASE_INITS.add(settings);
    // Store default state
    settings.defaultState =
        typeof module.state === 'function'
            ? __assign({}, module.state()) : __assign({}, module.state);
    // Normalize getters to retrieve database and reference
    var getDatabase = typeof database === 'function' ? database : function () { return database; };
    var getReference = typeof reference === 'function' ? reference : function () { return reference; };
    // Add extra getters
    var _d = settings.getters, DB = _d.DB, REF = _d.REF, STATE = _d.STATE;
    var cachedRef;
    var getters = __assign({}, (module.getters || {}), (_a = {}, _a[DB] = getDatabase, _a[REF] = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var newRef = getReference.apply(void 0, __spread(args));
        if (settings.initialized && newRef !== cachedRef && settings.reSync) {
            settings.initialized = false;
            settings.reSync(cachedRef, newRef);
            settings.initialized = true;
        }
        return (cachedRef = newRef);
    }, _a[STATE] = function (state) { return state; }, _a));
    try {
        // Register mutations
        for (var _e = __values(Object.keys(module.mutations || {})), _f = _e.next(); !_f.done; _f = _e.next()) {
            var mutation = _f.value;
            FIREBASE_MUTATIONS.set(mutation, settings);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
        }
        finally { if (e_1) throw e_1.error; }
    }
    // Handle database updates
    var addMutation = function (state, payload) {
        Vue.set(state, payload.key, payload.value);
    };
    var changeMutation = function (state, payload) {
        // For some reason it is required to delete the current state first,
        // otherwise getters will not be updated.
        Vue.delete(state, payload.key);
        Vue.set(state, payload.key, payload.value);
    };
    var removeMutation = function (state, payload) {
        Vue.delete(state, payload);
    };
    var resetMutation = function (state) {
        var e_2, _a, e_3, _b;
        try {
            // Clear current state
            for (var _c = __values(Object.keys(state)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var prop = _d.value;
                Vue.delete(state, prop);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_2) throw e_2.error; }
        }
        try {
            // Restore default state
            for (var _e = __values(Object.keys(settings.defaultState)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var prop = _f.value;
                Vue.set(state, prop, settings.defaultState[prop]);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
    // Add extra mutation
    var _g = settings.mutations, CHILD_ADD = _g.CHILD_ADD, CHILD_CHANGE = _g.CHILD_CHANGE, CHILD_REMOVE = _g.CHILD_REMOVE, RESET = _g.RESET;
    var mutations = __assign({}, (module.mutations || {}), (_c = {}, _c[CHILD_ADD] = addMutation, _c[CHILD_CHANGE] = changeMutation, _c[CHILD_REMOVE] = removeMutation, _c[RESET] = resetMutation, _c));
    return __assign({}, module, { getters: getters, mutations: mutations });
}
//# sourceMappingURL=module.js.map